#include "Test.h"

#define LCD_ENABLE_PIN PIN_A0
#define LCD_RS_PIN PIN_A1
#define LCD_RW_PIN PIN_A2
#define LCD_DATA4 PIN_A3
#define LCD_DATA5 PIN_A4
#define LCD_DATA6 PIN_A5
#define LCD_DATA7 PIN_A6
#define LCD_TYPE 2
#include <lcd.c>
#include <stdlib.h>
#define IS_LEAP(year) (year%4 == 0)
#define XTAL_FREQUENCY  4000000
#define TIMER1_FREQUENCY (XTAL_FREQUENCY / 4) 
int32 Ticker;
int8 Seconds=0;
int8 Year=0,Month=0,Days=0,Hours=0,Minutes=0;
void Initialize_RTC(void)
{
  Ticker = TIMER1_FREQUENCY;                  
  setup_timer_1( T1_INTERNAL | T1_DIV_BY_1 );            
  enable_interrupts( INT_TIMER1 );            
}
#int_TIMER1                               
void TIMER1_isr()                         
{
  Ticker -= 65536;                        
  if ( Ticker < 65536 )                   
  {  Ticker += TIMER1_FREQUENCY;          
     seconds++;                          
  }  
  if(Seconds == 60) {Minutes++; Seconds=0;
    if(Minutes == 60) {Hours++; Minutes=0;
      if(Hours == 24) {Days++; Hours=0;
        if (  (Days == 29 && Month==2 && !IS_LEAP(Year))
           || (Days == 30 && Month==2)
           || (Days == 31 && (Month==4 || Month==6 || Month==9 || Month==11 ))
           || (Days == 32)
           ) {Month++;Days=0;}
        if(Month == 13) {Year++; Month=0;}
  }}}
}

void Setup_PIC()
{
   setup_adc_ports(NO_ANALOGS|VSS_VDD);
   setup_adc(ADC_CLOCK_DIV_2);
   setup_spi(SPI_SS_DISABLED);
   setup_timer_0(RTCC_INTERNAL|RTCC_DIV_1);
   setup_timer_1(T1_DISABLED);
   setup_timer_2(T2_DISABLED,0,1);
   setup_ccp1(CCP_OFF);
   setup_comparator(NC_NC_NC_NC);
   setup_vref(FALSE);
   setup_oscillator(OSC_4MHZ|OSC_INTRC);
   set_tris_b(0xFF);
}
void main()
{
   int8 prev_second;
   char hours_str[3] = "";
   char minutes_str[3] = "";
   char seconds_str[3] = "";
   int8 min_down = 0;
   int8 hour_down= 0;
   int8 func_down = 0;
   int8 func_toggle = 0;
   Setup_PIC();
   lcd_init(); 
   Initialize_RTC();
   enable_interrupts( GLOBAL );
   while(1)
   {
      if((input_state(PIN_B4) == 1) && (func_down == 0))
      {
         func_down = 1;
         if(func_toggle == 1) {func_toggle = 0;} else {func_toggle = 1;}
      }
      if((input_state(PIN_B4) == 0) && (func_down == 1))
      {
         func_down = 0;
      }
      if((input_state(PIN_B6) == 1) && (hour_down == 0))
      {
         hours++;
         if(hours > 23)
         {
            hours = 0;
         }
         hour_down = 1;
      }
      if((input_state(PIN_B6) == 0) && (hour_down == 1))
      {
         hour_down = 0;
      }
      if((input_state(PIN_B7) == 1) && (min_down == 0))
      {
         minutes++;
         if(minutes > 59)
         {
            hours++;
            minutes = 0;
         }
         seconds = 0;
         min_down = 1;
      }
      if((input_state(PIN_B7) == 0) && (min_down == 1))
      {
         min_down = 0;
      }
      if (seconds != prev_second)
      {
         prev_second = seconds;
         if(Seconds == 60) {Minutes++; Seconds=0;}
         if(Minutes == 60) {Hours++; Minutes=0;}
         if(Hours == 24) {Days++; Hours=0;}
         
         if(hours < 10)
         {
            sprintf(hours_str,"%c%d",'0',hours);
         }
         else
         {
            sprintf(hours_str,"%d",hours);
         }
         if(minutes < 10)
         {
            sprintf(minutes_str,"%c%d",'0',minutes);
         }
         else
         {
            sprintf(minutes_str,"%d",minutes);
         }
         if(seconds < 10)
         {
            sprintf(seconds_str,"%c%d",'0',seconds);
         }
         else
         {
            sprintf(seconds_str,"%d",seconds);
         }
         lcd_putc('\f');
         lcd_gotoxy(1,1);        
         printf(lcd_putc, "%s:%s:%s",hours_str, minutes_str, seconds_str);
         if(func_toggle == 1)
         {
            lcd_gotoxy(1,2);
            printf(lcd_putc,"LCD 2nd Line.");
         }
      } 
   } 
}
